HDU3183 A Magic Lamp (RMQ & ST)

来源:互联网 发布:oracle 执行sql文件 编辑:程序博客网 时间:2024/06/05 07:59

A Magic Lamp

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4660    Accepted Submission(s): 1927


Problem Description
Kiki likes traveling. One day she finds a magic lamp, unfortunately the genie in the lamp is not so kind. Kiki must answer a question, and then the genie will realize one of her dreams. 
The question is: give you an integer, you are allowed to delete exactly m digits. The left digits will form a new integer. You should make it minimum.
You are not allowed to change the order of the digits. Now can you help Kiki to realize her dream?
 

Input
There are several test cases.
Each test case will contain an integer you are given (which may at most contains 1000 digits.) and the integer m (if the integer contains n digits, m will not bigger then n). The given integer will not contain leading zero.
 

Output
For each case, output the minimum result you can get in one line.
If the result contains leading zero, ignore it. 
 

Sample Input
178543 4 1000001 1100001 212345 254321 2
 

Sample Output
1310123321
 

Source
HDU 2009-11 Programming Contest


题意:从一个长度为n的字符串中删除m个元素,使得新的数字最小。

思路:因为要删除m个数字,所以前m+1个中的最小的数字一定不会被删除,找到该位置indx,然后从该位置的下一个位置开始再找m+1个数,循环n-m次,最后剩下的元素醉成的整数则一定是最小的。


AC代码如下:

#include <cstdio>#include <cmath>#include <cstring>#include <algorithm>using namespace std;char str[1010],a[1010];int m,len,dp[1010][11]; int Min(int x, int y){return str[x] <= str[y] ? x : y;}void RMQ_init(){for(int i = 0; i < len; i ++) dp[i][0] = i;for(int j = 1; (1 << j) <= len; j ++){for(int i = 0; i + (1 << j) - 1 < len; i ++){dp[i][j] = Min(dp[i][j-1],dp[i+(1 << (j-1))][j-1]);}}}int RMQ(int i, int j){int k = 0;while(1 << (k + 1) <= j-i+1) k ++;          return Min(dp[i][k],dp[j-(1 << k) + 1][k]);}int main(){while(~scanf("%s%d",str,&m)){len = strlen(str);RMQ_init();int k = 0,indx=0;m = len - m; while(m --){ indx = RMQ(indx,len-(m+1));a[k ++] = str[indx ++];  } int flag = 0;for(indx = 0; indx < k; indx ++) if(a[indx] != '0') break;if(indx == k) printf("0\n");else{while(indx < k) printf("%c",a[indx ++]);printf("\n");}}return 0;}


原创粉丝点击